;----------------------------
;--yet another funny clocks--
;-------made by asmfan-------
;----------------------------

format	PE GUI 4.0
entry	start

include 'win32a.inc'


MAX_PATH	EQU	260

struct	POINTS
x	dw	?
y	dw	?
ends


id_timer	EQU	1

mn_font 	EQU	10h
mn_fontcolor	EQU	20h
mn_bkcolor	EQU	30h
mn_close	EQU	40h
mn_about	EQU	50h		; least 4 bits must be 0 - used by Win internally in WM_SYSCOMMAND
mn_topmost	EQU	60h		; least 4 bits must be 0 - used by Win internally in WM_SYSCOMMAND
mn_taskbar	EQU	70h

initial_fontcolor	EQU	0FF00h
initial_bkColor EQU	505050h
initial_mn_topmost	EQU	MF_CHECKED
initial_mn_taskbar	EQU	MF_CHECKED
initial_mn_about	EQU	MF_UNCHECKED


;-------------------------------------------------------------------------
;section '.text' code readable executable
start:
	xor	esi,esi
	sub	esp,sizeof.WNDCLASSEX

	lea	edi,[esp]
	mov	ecx,sizeof.WNDCLASSEX/4
	xor	eax,eax
	rep	stosd

	invoke	GetModuleHandle,esi
	mov	ebx,eax

	mov	[esp+WNDCLASSEX.cbSize],sizeof.WNDCLASSEX
	mov	[esp+WNDCLASSEX.hInstance],ebx
	mov	[esp+WNDCLASSEX.style],CS_HREDRAW OR CS_VREDRAW
	mov	[esp+WNDCLASSEX.lpfnWndProc],WndProc
	mov	[esp+WNDCLASSEX.lpszClassName],class_name

	invoke	LoadIcon,ebx,1
	mov	[esp+WNDCLASSEX.hIconSm],eax

	invoke	LoadIcon,ebx,2
	mov	[esp+WNDCLASSEX.hIcon],eax

	invoke	LoadCursor,esi,IDC_CROSS
	mov	[esp+WNDCLASSEX.hCursor],eax

	invoke	RegisterClassEx,esp
	add	esp,sizeof.WNDCLASSEX

	test	eax,eax
	jz	window_message_loop_end


	invoke	CreateWindowEx, WS_EX_TOPMOST,\
				class_name, window_name,\
				WS_POPUP OR WS_VISIBLE OR WS_SYSMENU OR WS_MINIMIZEBOX OR WS_BORDER,\
				CW_USEDEFAULT, CW_USEDEFAULT,\
				200,200,\
				esi,\
				esi,\
				ebx,\
				esi

	test	eax,eax
	jz	window_message_loop_end

	lea	ebx,[msg]
	jmp	@F

msg_loop:
	invoke	TranslateMessage,ebx
	invoke	DispatchMessage,ebx

@@:	invoke	GetMessage,ebx,NULL,esi,esi
	test	al,al
	jnz	msg_loop

window_message_loop_end:
	invoke	ExitProcess,[msg.wParam]


;-----------------------------------------------
proc	WndProc uses ebx esi edi	,hWnd,uMsg,wParam,lParam
local	_ps:PAINTSTRUCT, _stime:SYSTEMTIME, _ccs:CHOOSECOLOR, _cfs:CHOOSEFONT, _rect:RECT

	mov	eax,[uMsg]

	cmp	eax,WM_TIMER
	je	.wm_timer
	cmp	eax,WM_PAINT
	je	.wm_paint
	cmp	eax,WM_LBUTTONDOWN
	je	.wm_lbuttondown
	cmp	eax,WM_MOUSEMOVE
	je	.wm_mousemove
	cmp	eax,WM_LBUTTONUP
	je	.wm_lbuttonup
	cmp	eax,WM_SYSCOMMAND
	je	.wm_syscommand
	cmp	eax,WM_CONTEXTMENU
	je	.wm_contextmenu
	cmp	eax,WM_COMMAND
	je	.wm_command
	cmp	eax,WM_CREATE
	je	.wm_create
	cmp	eax,WM_DESTROY
	je	.wm_destroy

.def_finish:
	;=======================================
	pop	edi esi ebx
	leave
	jmp	[DefWindowProc]
	;---------------------------------------

.wm_timer:
	;=======================================
	mov	eax,[_flashflag]
	test	al,al
	jz	@F

	invoke	FlashWindow,[hWnd],eax
@@:
	lea	eax,[_stime]
	invoke	GetLocalTime,eax
	movzx	edi,[_stime.wSecond]

	cmp	edi,[_wSec]
	je	@F

	mov	[_wSec],edi
	movzx	eax,[_stime.wHour]
	movzx	ebx,[_stime.wMinute]

	cinvoke wsprintf, _timbuf, _time, eax, ebx, edi

	invoke	lstrcpy,_buf,_datbuf
	invoke	lstrcat,_buf,_timbuf

	invoke	SetWindowText,[hWnd],_timbuf

	invoke	InvalidateRect,[hWnd],NULL,TRUE
@@:
	xor	eax,eax
	jmp	.finish
	;---------------------------------------

.wm_paint:
	;=======================================
	lea	edi,[_ps]
	invoke	BeginPaint,[hWnd],edi
	mov	esi,eax

	invoke	SelectObject,esi,[_hfont]
	mov	ebx,eax

	invoke	SetBkMode,esi,TRANSPARENT
	invoke	SetTextColor,esi,[_fontcolor]
	invoke	TextOut,esi,0,0, _buf, sizeof._buf-1

	invoke	SelectObject,esi,ebx

	invoke	EndPaint,[hWnd],edi

	xor	eax,eax
	jmp	.finish
	;---------------------------------------

.wm_lbuttondown:
	;=======================================
	invoke	SetCapture,[hWnd]

	mov	eax,[lParam]
	mov	[_currpos],eax

	invoke	GetWindowRect,[hWnd],_moverect

	invoke	SetCursor,[_hcur]
	mov	[_hcur],eax

	xor	eax,eax
	jmp	.finish
	;---------------------------------------

.wm_mousemove:
	;=======================================
	mov	eax,[wParam]
	test	eax,MK_LBUTTON
	jz	@F

	mov	edx,[lParam]

	movsx	ecx,WORD [_currpos]
	movsx	ebx,WORD [_currpos+2]

	movsx	eax,dx
	sar	edx,16

	sub	eax,ecx
	sub	edx,ebx

	add	eax,[_moverect.left]
	add	edx,[_moverect.top]

	mov	[_moverect.left],eax
	mov	[_moverect.top],edx

	invoke	SetWindowPos,[hWnd],0,eax,edx,0,0,SWP_NOSIZE OR SWP_NOZORDER
@@:
	xor	eax,eax
	jmp	.finish
	;---------------------------------------

.wm_lbuttonup:
	;=======================================
	invoke	SetCursor,[_hcur]
	mov	[_hcur],eax

	invoke	ReleaseCapture

	xor	eax,eax
	jmp	.finish
	;---------------------------------------

.wm_syscommand:
	;=======================================
	mov	eax,[wParam]
	and	eax,0FFF0h

	cmp	eax,mn_about
	je	.menu_about
	cmp	eax,mn_topmost
	je	.menu_topmost
	cmp	eax,mn_close
	je	.wm_destroy

	jmp	.def_finish
	;---------------------------------------

.wm_contextmenu:
	;=======================================
	movzx	eax, WORD [lParam]
	movzx	ebx, WORD [lParam+2]
	invoke	TrackPopupMenuEx,[_hmenu],TPM_LEFTALIGN,eax,ebx,[hWnd],NULL

	jmp	.finish
	;---------------------------------------

.wm_command:
	;=======================================
	movzx	eax,WORD [wParam]

	cmp	eax,mn_about
	je	.menu_about
	cmp	eax,mn_topmost
	je	.menu_topmost
	cmp	eax,mn_taskbar
	je	.menu_taskbar
	cmp	eax,mn_font
	je	.menu_font
	cmp	eax,mn_fontcolor
	je	.menu_fontcolor
	cmp	eax,mn_bkcolor
	je	.menu_bkcolor
	cmp	eax,mn_close
	je	.wm_destroy

	jmp	.finish
	;---------------------------------------

.menu_about:
	;=======================================
	invoke	GetMenuState,[_hmenu],mn_about,MF_BYCOMMAND

	mov	ebx,MF_CHECKED
	mov	edx,MF_UNCHECKED

	test	eax,ebx
	cmovnz	ebx,edx

	invoke	CheckMenuItem,[_hmenu],mn_about,ebx
	invoke	CheckMenuItem,[_hsysmenu],mn_about,ebx

	or	[_flashflag],1
	invoke	MessageBox, [hWnd], about_text, about_capt, MB_ICONINFORMATION OR MB_OK
	and	[_flashflag],0

	xor	eax,eax
	jmp	.finish
	;---------------------------------------

.menu_topmost:
	;=======================================
	invoke	GetMenuState,[_hmenu],mn_topmost,MF_BYCOMMAND

	mov	ebx,MF_CHECKED
	mov	edx,MF_UNCHECKED

	mov	ecx,HWND_NOTOPMOST
	mov	esi,HWND_TOPMOST

	mov	edi,MF_ENABLED

	test	eax,ebx
	cmovnz	ebx,edx
	cmovnz	esi,ecx
	mov	edx,MF_GRAYED
	cmovnz	edi,edx

	invoke	CheckMenuItem,[_hmenu],mn_topmost,ebx
	invoke	CheckMenuItem,[_hsysmenu],mn_topmost,ebx

	invoke	EnableMenuItem,[_hmenu],mn_taskbar,edi

	invoke	SetWindowPos,[hWnd],esi,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE

	xor	eax,eax
	jmp	.finish
	;---------------------------------------

.menu_taskbar:
	;=======================================
	invoke	GetMenuState,[_hmenu],mn_taskbar,MF_BYCOMMAND

	mov	ebx,MF_CHECKED
	mov	edx,MF_UNCHECKED

	mov	esi,NOT WS_EX_TOOLWINDOW
	or	ecx,-1

	mov	edi,MF_ENABLED

	test	eax,ebx
	cmovnz	ebx,edx
	cmovnz	esi,ecx
	mov	edx,MF_GRAYED
	cmovnz	edi,edx

	invoke	ShowWindow,[hWnd],SW_HIDE
	invoke	GetWindowLong,[hWnd],GWL_EXSTYLE
	or	eax,WS_EX_TOOLWINDOW
	and	eax,esi
	invoke	SetWindowLong,[hWnd],GWL_EXSTYLE,eax
	invoke	ShowWindow,[hWnd],SW_SHOW

	invoke	CheckMenuItem,[_hmenu],mn_taskbar,ebx

	invoke	EnableMenuItem,[_hmenu],mn_topmost,edi
	invoke	EnableMenuItem,[_hsysmenu],mn_topmost,edi

	xor	eax,eax
	jmp	.finish
	;---------------------------------------

.menu_font:
	;=======================================
	lea	edi,[_cfs]
	mov	ecx,sizeof.CHOOSEFONT/4
	xor	eax,eax
	rep	stosd

	mov	[_cfs.lStructSize],sizeof.CHOOSEFONT
	mov	eax,[hWnd]
	mov	[_cfs.hwndOwner],eax
	mov	[_cfs.lpLogFont],_logfont
	mov	[_cfs.Flags],CF_INITTOLOGFONTSTRUCT OR CF_SCREENFONTS

	lea	eax,[_cfs]
	invoke	ChooseFont,eax
	test	al,al
	jz	@F


	invoke	CreateFontIndirect,_logfont
	mov	esi,eax
	xchg	[_hfont],eax

	invoke	DeleteObject,eax

	invoke	GetDC,[hWnd]
	mov	ebx,eax

	invoke	SelectObject,ebx,esi
	mov	esi,eax
	invoke	GetTextExtentPoint32, ebx, _buf, sizeof._buf-1, _textsize
	invoke	SelectObject,ebx,esi

	invoke	ReleaseDC,[hWnd],ebx

	lea	eax,[_rect]
	invoke	GetClientRect,[hWnd],eax
	mov	esi,[_rect.right]
	mov	ebx,[_rect.bottom]

	sub	esi,[_textsize.cx]
	sub	ebx,[_textsize.cy]

	neg	esi
	neg	ebx

	lea	eax,[_rect]
	invoke	GetWindowRect,[hWnd],eax
	add	esi,[_rect.right]
	add	ebx,[_rect.bottom]
	sub	esi,[_rect.left]
	sub	ebx,[_rect.top]

	invoke	SetWindowPos,[hWnd],0,0,0,esi,ebx,SWP_NOMOVE OR SWP_NOZORDER
@@:
	xor	eax,eax
	jmp	.finish
	;---------------------------------------

.menu_fontcolor:
	;=======================================
	lea	edi,[_ccs]
	mov	ecx,sizeof.CHOOSECOLOR/4
	xor	eax,eax
	rep	stosd

	mov	[_ccs.lStructSize],sizeof.CHOOSECOLOR
	mov	eax,[hWnd]
	mov	[_ccs.hwndOwner],eax

	push	[_fontcolor]
	pop	[_ccs.rgbResult]

	mov	[_ccs.lpCustColors],_custColors1
	mov	[_ccs.Flags],CC_FULLOPEN OR CC_RGBINIT

	lea	eax,[_ccs]
	invoke	ChooseColor,eax
	test	al,al
	jz	@F

	push	[_ccs.rgbResult]
	pop	[_fontcolor]

	invoke	InvalidateRect,[hWnd],NULL,TRUE
@@:
	xor	eax,eax
	jmp	.finish
	;---------------------------------------

.menu_bkcolor:
	;=======================================
	lea	edi,[_ccs]
	mov	ecx,sizeof.CHOOSECOLOR/4
	xor	eax,eax
	rep	stosd

	mov	[_ccs.lStructSize],sizeof.CHOOSECOLOR
	mov	eax,[hWnd]
	mov	[_ccs.hwndOwner],eax

	push	[_bkColor]
	pop	[_ccs.rgbResult]

	mov	[_ccs.lpCustColors],_custColors2
	mov	[_ccs.Flags],CC_FULLOPEN OR CC_RGBINIT

	lea	eax,[_ccs]
	invoke	ChooseColor,eax
	test	al,al
	jz	@F

	mov	eax,[_ccs.rgbResult]
	mov	[_bkColor],eax

	invoke	CreateSolidBrush,eax
	invoke	SetClassLong,[hWnd],GCL_HBRBACKGROUND,eax
	invoke	DeleteObject,eax
	invoke	InvalidateRect,[hWnd],NULL,TRUE
@@:
	xor	eax,eax
	jmp	.finish
	;---------------------------------------

.wm_create:
	;=======================================
	invoke	GetCurrentProcess
	invoke	SetPriorityClass,eax,IDLE_PRIORITY_CLASS
	invoke	GetCurrentThread
	invoke	SetThreadPriority,eax,THREAD_PRIORITY_IDLE

	invoke	SetTimer,[hWnd],id_timer,300,NULL		; 0.3 second interval
	mov	[_timer],eax

	invoke	LoadCursor,NULL,IDC_HAND
	mov	[_hcur],eax

	invoke	CreatePopupMenu
	mov	[_hmenu],eax
	mov	esi,eax

	mov	ebx,AppendMenu					; address of thunk

	stdcall DWORD [ebx],esi,MF_STRING,mn_taskbar,_taskbar_msg
	stdcall DWORD [ebx],esi,MF_SEPARATOR,0,0
	stdcall DWORD [ebx],esi,MF_STRING,mn_topmost,_topmost_msg
	stdcall DWORD [ebx],esi,MF_STRING OR MF_MENUBARBREAK,mn_font,_font_msg
	stdcall DWORD [ebx],esi,MF_STRING,mn_fontcolor,_color_msg
	stdcall DWORD [ebx],esi,MF_STRING,mn_bkcolor,_bkcolor_msg
	stdcall DWORD [ebx],esi,MF_STRING OR MF_MENUBREAK,mn_about,_about_msg
	stdcall DWORD [ebx],esi,MF_SEPARATOR,0,0
	stdcall DWORD [ebx],esi,MF_STRING,mn_close,_close_msg

	invoke	GetSystemMenu,[hWnd],FALSE
	mov	edi,eax
	mov	[_hsysmenu],eax

	mov	ebx,[ebx]					; API func itself

	stdcall ebx,edi,MF_SEPARATOR,0,0
	stdcall ebx,edi,MF_SEPARATOR OR MF_MENUBARBREAK,0,0
	stdcall ebx,edi,MF_STRING,mn_about,_about_msg
	stdcall ebx,edi,MF_STRING,mn_topmost,_topmost_msg
	stdcall ebx,edi,MF_SEPARATOR,0,0
	stdcall ebx,edi,MF_STRING,mn_close,_close_msg


	mov	ebx,[lParam]
	mov	ebx,[ebx+CREATESTRUCT.hInstance]
	invoke	LoadBitmap,ebx,3
	mov	esi,eax

	invoke	SetMenuItemBitmaps,[_hmenu],mn_topmost,MF_BYCOMMAND,0,esi
	invoke	SetMenuItemBitmaps,edi,mn_topmost,MF_BYCOMMAND,0,esi

	invoke	SetMenuItemBitmaps,[_hmenu],mn_taskbar,MF_BYCOMMAND,0,esi

	invoke	LoadBitmap,ebx,1
	mov	esi,eax

	invoke	LoadBitmap,ebx,2
	mov	ebx,eax

	invoke	SetMenuItemBitmaps,[_hmenu],mn_about,MF_BYCOMMAND,esi,ebx
	invoke	SetMenuItemBitmaps,edi,mn_about,MF_BYCOMMAND,esi,ebx

	mov	esi,initial_mn_topmost
	invoke	CheckMenuItem,[_hmenu],mn_topmost,esi
	invoke	CheckMenuItem,edi,mn_topmost,esi

	mov	esi,initial_mn_taskbar
	invoke	CheckMenuItem,[_hmenu],mn_taskbar,esi

	mov	ebx,initial_mn_about
	invoke	CheckMenuItem,[_hmenu],mn_about,ebx
	invoke	CheckMenuItem,edi,mn_about,ebx

	lea	edx,[_stime]
	invoke	GetLocalTime,edx

	movzx	eax,[_stime.wDay]
	movzx	ebx,[_stime.wMonth]
	movzx	edi,[_stime.wYear]
	cinvoke wsprintf, _datbuf, _date, eax, ebx, edi

	movzx	eax,[_stime.wHour]
	movzx	ebx,[_stime.wMinute]
	movzx	edi,[_stime.wSecond]
	cinvoke wsprintf, _timbuf, _time, eax, ebx, edi

	mov	[_wSec],edi

	invoke	lstrcpy,_buf,_datbuf
	invoke	lstrcat,_buf,_timbuf

	invoke	SetWindowText,[hWnd],_timbuf

	invoke	GetDC,[hWnd]
	mov	ebx,eax

	invoke	GetStockObject,SYSTEM_FIXED_FONT
	mov	esi,eax
	mov	[_hfont],eax
	invoke	GetObject,esi,sizeof.LOGFONT,_logfont

	invoke	SelectObject,ebx,esi
	mov	edi,eax
	invoke	GetTextExtentPoint32, ebx, _buf, sizeof._buf-1, _textsize
	invoke	SelectObject,ebx,edi

	invoke	ReleaseDC,[hWnd],ebx

	lea	eax,[_rect]
	invoke	GetClientRect,[hWnd],eax
	mov	esi,[_rect.right]
	mov	ebx,[_rect.bottom]

	sub	esi,[_textsize.cx]
	sub	ebx,[_textsize.cy]

	neg	esi
	neg	ebx

	lea	eax,[_rect]
	invoke	GetWindowRect,[hWnd],eax
	add	esi,[_rect.right]
	add	ebx,[_rect.bottom]
	sub	esi,[_rect.left]
	sub	ebx,[_rect.top]

	invoke	GetModuleFileName,NULL,_filePath,MAX_PATH
	lea	edi,[eax+_filePath]
	mov	al,'.'
	or	ecx,-1
	std
	repne	scasb
	cld
	add	edi,2
	mov	eax,'ini'
	mov	[edi],eax

	invoke	GetPrivateProfileInt,_sectionName,_keyFontcolor,initial_fontcolor,_filePath
	mov	[_fontcolor],eax

	invoke	GetPrivateProfileInt,_sectionName,_keyBkColor,initial_bkColor,_filePath
	mov	[_bkColor],eax
	invoke	CreateSolidBrush,eax
	invoke	SetClassLong,[hWnd],GCL_HBRBACKGROUND,eax

	invoke	GetPrivateProfileInt,_sectionName,_keyX,0,_filePath
	mov	edi,eax

	invoke	GetPrivateProfileInt,_sectionName,_keyY,0,_filePath

	mov	[_moverect.left],edi
	mov	[_moverect.top],eax

	invoke	SetWindowPos,[hWnd],0,edi,eax,esi,ebx,SWP_NOZORDER

	xor	eax,eax
	jmp	.finish
	;---------------------------------------

.wm_destroy:
	;=======================================
	invoke	GetSystemMenu,[hWnd],TRUE
	invoke	KillTimer,[hWnd],[_timer]
	invoke	DeleteObject,[_hfont]
	invoke	DestroyMenu,[_hmenu]

	mov	esi,[_moverect.left]
	mov	edi,[_moverect.top]

	mov	ebx,[WritePrivateProfileString]

	cinvoke wsprintf,_INIbuf,_format,esi
	stdcall ebx,_sectionName,_keyX,_INIbuf,_filePath

	cinvoke wsprintf,_INIbuf,_format,edi
	stdcall ebx,_sectionName,_keyY,_INIbuf,_filePath

	cinvoke wsprintf,_INIbuf,_format,[_fontcolor]
	stdcall ebx,_sectionName,_keyFontcolor,_INIbuf,_filePath

	cinvoke wsprintf,_INIbuf,_format,[_bkColor]
	stdcall ebx,_sectionName,_keyBkColor,_INIbuf,_filePath

	invoke	PostQuitMessage,[wParam]

	xor	eax,eax
;        jmp     .finish
	;---------------------------------------

.finish:
	;=======================================
	ret
	;---------------------------------------
endp
;-----------------------------------------------


;-------------------------------------------------------------------------
;section '.idata' data import readable
data	import

library kernel32, 'KERNEL32.DLL',\
	user32, 'USER32.DLL',\
	gdi32, 'GDI32.DLL',\
	comdlg32, 'COMDLG32.DLL'

include 'APIA\kernel32.inc'
include 'APIA\user32.inc'
include 'APIA\gdi32.inc'
include 'APIA\comdlg32.inc'

end	data


;-------------------------------------------------------------------------
;section '.rsrc' data resource readable
data	resource

directory	RT_GROUP_ICON,grp_icons,\
		RT_ICON,icons,\
		RT_BITMAP,bitmaps

resource	grp_icons,\
		1,LANG_NEUTRAL,main_icon,\
		2,LANG_NEUTRAL,other_icon
resource	icons,\
		1,LANG_NEUTRAL,first_icon_data,\
		2,LANG_NEUTRAL,second_icon_data
resource	bitmaps,\
		1,LANG_NEUTRAL,bmp1,\
		2,LANG_NEUTRAL,bmp2,\
		3,LANG_NEUTRAL,bmp3

icon	main_icon,first_icon_data,'rsrc\interface.ico'
icon	other_icon,second_icon_data,'rsrc\radiation.ico'
bitmap	bmp1,'rsrc\smile.bmp'
bitmap	bmp2,'rsrc\wink.bmp'
bitmap	bmp3,'rsrc\downb.bmp'

end	data


;-------------------------------------------------------------------------
;section '.data' data readable writeable
class_name	DB	'clock_class',0
window_name	DB	'clock_window',0
_font_msg	DB	'setup font',0
_color_msg	DB	'setup font color',0
_bkcolor_msg	DB	'background color',0
_topmost_msg	DB	'Topmost',0
_about_msg	DB	'About',0
_close_msg	DB	'Quit',0
_taskbar_msg	DB	'Taskbar',0
about_capt	DB	'About clocks',0
about_text	DB	'Just yet another clocks, unleashing the power of Win32API & Assembly.',0Dh,0Ah
		DB	'Written entirely in assembly using FASM, thx 2 Tomasz (aka Privalov)!',0Dh,0Ah,0Dh,0Ah
		DB	9,9,9,9,9,'handmade forever!',0Dh,0Ah
		DB	9,9,9,9,9,'asmfan.',0

_sectionName	DB	'attributes',0
_keyX	DB	'X',0
_keyY	DB	'Y',0
_keyFontcolor	DB	'Color',0
_keyBkColor	DB	'Background',0
_format DB	'%u',0

_date	DB	'%02u/%02u/%4u - ',0
_time	DB	'%02u:%02u:%02u',0
_datbuf RB	14
_timbuf RB	9
_buf	RB	$ - _datbuf - 1
sizeof._buf = $ - _buf

_INIbuf RB	12

ALIGN	4
msg		MSG
_logfont	LOGFONT
_textsize	SIZE
_moverect	RECT
_currpos	POINTS

_bkColor	DD	?
_fontcolor	DD	?
_hmenu	DD	?
_hsysmenu	DD	?
_hfont	DD	?
_timer	DD	?
_hcur	DD	?
_wSec	DD	?
_flashflag	DD	?

_custColors1	DD	16 DUP (?)
_custColors2	RD	16

_filePath	DB	MAX_PATH DUP(?)